<?php

declare(strict_types=1);

namespace DoctrineMigrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20240320151429 extends AbstractMigration
{
    public function getDescription(): string
    {
        return '';
    }

    public function up(Schema $schema): void
    {
        // this up() migration is auto-generated, please modify it to your needs
        $this->addSql('CREATE SEQUENCE collectionner_id_seq INCREMENT BY 1 MINVALUE 1 START 1');
        $this->addSql('CREATE SEQUENCE collectionneur_id_seq INCREMENT BY 1 MINVALUE 1 START 1');
        $this->addSql('CREATE SEQUENCE piece_caracteristique_id_seq INCREMENT BY 1 MINVALUE 1 START 1');
        $this->addSql('CREATE SEQUENCE piece_pays_id_seq INCREMENT BY 1 MINVALUE 1 START 1');
        $this->addSql('CREATE SEQUENCE piece_tranche_id_seq INCREMENT BY 1 MINVALUE 1 START 1');
        $this->addSql('CREATE TABLE collectionner (id INT NOT NULL, qte_collection INT NOT NULL, PRIMARY KEY(id))');
        $this->addSql('CREATE TABLE collectionneur (id INT NOT NULL, collectionner_id INT NOT NULL, collectionneur_nom VARCHAR(250) NOT NULL, collectionneur_prenom VARCHAR(250) NOT NULL, PRIMARY KEY(id))');
        $this->addSql('CREATE INDEX IDX_BD007DDA4718174E ON collectionneur (collectionner_id)');
        $this->addSql('CREATE TABLE piece_caracteristique (id INT NOT NULL, face_commune VARCHAR(250) NOT NULL, masse INT NOT NULL, taille INT NOT NULL, materiau VARCHAR(75) NOT NULL, PRIMARY KEY(id))');
        $this->addSql('CREATE TABLE piece_pays (id INT NOT NULL, pays_nom VARCHAR(250) NOT NULL, PRIMARY KEY(id))');
        $this->addSql('CREATE TABLE piece_tranche (id INT NOT NULL, tranche VARCHAR(250) NOT NULL, PRIMARY KEY(id))');
        $this->addSql('ALTER TABLE collectionneur ADD CONSTRAINT FK_BD007DDA4718174E FOREIGN KEY (collectionner_id) REFERENCES collectionner (id) NOT DEFERRABLE INITIALLY IMMEDIATE');
        $this->addSql('ALTER TABLE piece_modele ADD piece_pays_id INT NOT NULL');
        $this->addSql('ALTER TABLE piece_modele ADD piece_tranche_id INT NOT NULL');
        $this->addSql('ALTER TABLE piece_modele ADD piece_caracteristique_id INT NOT NULL');
        $this->addSql('ALTER TABLE piece_modele ADD collectionner_id INT NOT NULL');
        $this->addSql('ALTER TABLE piece_modele ADD CONSTRAINT FK_CA708E09BA52512D FOREIGN KEY (piece_pays_id) REFERENCES piece_pays (id) NOT DEFERRABLE INITIALLY IMMEDIATE');
        $this->addSql('ALTER TABLE piece_modele ADD CONSTRAINT FK_CA708E09B384CCA9 FOREIGN KEY (piece_tranche_id) REFERENCES piece_tranche (id) NOT DEFERRABLE INITIALLY IMMEDIATE');
        $this->addSql('ALTER TABLE piece_modele ADD CONSTRAINT FK_CA708E09E06EE192 FOREIGN KEY (piece_caracteristique_id) REFERENCES piece_caracteristique (id) NOT DEFERRABLE INITIALLY IMMEDIATE');
        $this->addSql('ALTER TABLE piece_modele ADD CONSTRAINT FK_CA708E094718174E FOREIGN KEY (collectionner_id) REFERENCES collectionner (id) NOT DEFERRABLE INITIALLY IMMEDIATE');
        $this->addSql('CREATE INDEX IDX_CA708E09BA52512D ON piece_modele (piece_pays_id)');
        $this->addSql('CREATE INDEX IDX_CA708E09B384CCA9 ON piece_modele (piece_tranche_id)');
        $this->addSql('CREATE INDEX IDX_CA708E09E06EE192 ON piece_modele (piece_caracteristique_id)');
        $this->addSql('CREATE INDEX IDX_CA708E094718174E ON piece_modele (collectionner_id)');
    }

    public function down(Schema $schema): void
    {
        // this down() migration is auto-generated, please modify it to your needs
        $this->addSql('CREATE SCHEMA public');
        $this->addSql('ALTER TABLE piece_modele DROP CONSTRAINT FK_CA708E094718174E');
        $this->addSql('ALTER TABLE piece_modele DROP CONSTRAINT FK_CA708E09E06EE192');
        $this->addSql('ALTER TABLE piece_modele DROP CONSTRAINT FK_CA708E09BA52512D');
        $this->addSql('ALTER TABLE piece_modele DROP CONSTRAINT FK_CA708E09B384CCA9');
        $this->addSql('DROP SEQUENCE collectionner_id_seq CASCADE');
        $this->addSql('DROP SEQUENCE collectionneur_id_seq CASCADE');
        $this->addSql('DROP SEQUENCE piece_caracteristique_id_seq CASCADE');
        $this->addSql('DROP SEQUENCE piece_pays_id_seq CASCADE');
        $this->addSql('DROP SEQUENCE piece_tranche_id_seq CASCADE');
        $this->addSql('ALTER TABLE collectionneur DROP CONSTRAINT FK_BD007DDA4718174E');
        $this->addSql('DROP TABLE collectionner');
        $this->addSql('DROP TABLE collectionneur');
        $this->addSql('DROP TABLE piece_caracteristique');
        $this->addSql('DROP TABLE piece_pays');
        $this->addSql('DROP TABLE piece_tranche');
        $this->addSql('DROP INDEX IDX_CA708E09BA52512D');
        $this->addSql('DROP INDEX IDX_CA708E09B384CCA9');
        $this->addSql('DROP INDEX IDX_CA708E09E06EE192');
        $this->addSql('DROP INDEX IDX_CA708E094718174E');
        $this->addSql('ALTER TABLE piece_modele DROP piece_pays_id');
        $this->addSql('ALTER TABLE piece_modele DROP piece_tranche_id');
        $this->addSql('ALTER TABLE piece_modele DROP piece_caracteristique_id');
        $this->addSql('ALTER TABLE piece_modele DROP collectionner_id');
    }
}
