<?php

namespace App\Entity;

use App\Repository\CollectionnerRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: CollectionnerRepository::class)]
class Collectionner
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\OneToMany(targetEntity: Collectionneur::class, mappedBy: 'collectionner')]
    private Collection $collectionneurID;

    #[ORM\OneToMany(targetEntity: PieceModele::class, mappedBy: 'collectionner')]
    private Collection $pieceModeleID;

    #[ORM\Column]
    private ?int $qteCollection = null;

    public function __construct()
    {
        $this->collectionneurID = new ArrayCollection();
        $this->pieceModeleID = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    /**
     * @return Collection<int, Collectionneur>
     */
    public function getCollectionneurID(): Collection
    {
        return $this->collectionneurID;
    }

    public function addCollectionneurID(Collectionneur $collectionneurID): static
    {
        if (!$this->collectionneurID->contains($collectionneurID)) {
            $this->collectionneurID->add($collectionneurID);
            $collectionneurID->setCollectionner($this);
        }

        return $this;
    }

    public function removeCollectionneurID(Collectionneur $collectionneurID): static
    {
        if ($this->collectionneurID->removeElement($collectionneurID)) {
            // set the owning side to null (unless already changed)
            if ($collectionneurID->getCollectionner() === $this) {
                $collectionneurID->setCollectionner(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection<int, PieceModele>
     */
    public function getPieceModeleID(): Collection
    {
        return $this->pieceModeleID;
    }

    public function addPieceModeleID(PieceModele $pieceModeleID): static
    {
        if (!$this->pieceModeleID->contains($pieceModeleID)) {
            $this->pieceModeleID->add($pieceModeleID);
            $pieceModeleID->setCollectionner($this);
        }

        return $this;
    }

    public function removePieceModeleID(PieceModele $pieceModeleID): static
    {
        if ($this->pieceModeleID->removeElement($pieceModeleID)) {
            // set the owning side to null (unless already changed)
            if ($pieceModeleID->getCollectionner() === $this) {
                $pieceModeleID->setCollectionner(null);
            }
        }

        return $this;
    }

    public function getQteCollection(): ?int
    {
        return $this->qteCollection;
    }

    public function setQteCollection(int $qteCollection): static
    {
        $this->qteCollection = $qteCollection;

        return $this;
    }
}
