<?php

namespace App\Entity;

use App\Repository\PieceCaracteristiqueRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: PieceCaracteristiqueRepository::class)]
class PieceCaracteristique
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\OneToMany(targetEntity: PieceModele::class, mappedBy: 'pieceCaracteristique')]
    private Collection $pieceModeleID;

    #[ORM\Column(length: 250)]
    private ?string $pieceFaceCommune = null;

    #[ORM\Column]
    private ?int $pieceMasse = null;

    #[ORM\Column]
    private ?int $pieceTaille = null;

    #[ORM\Column(length: 75)]
    private ?string $pieceMateriau = null;

    public function __construct()
    {
        $this->pieceModeleID = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    /**
     * @return Collection<int, PieceModele>
     */
    public function getPieceModeleID(): Collection
    {
        return $this->pieceModeleID;
    }

    public function addPieceModeleID(PieceModele $pieceModeleID): static
    {
        if (!$this->pieceModeleID->contains($pieceModeleID)) {
            $this->pieceModeleID->add($pieceModeleID);
            $pieceModeleID->setPieceCaracteristique($this);
        }

        return $this;
    }

    public function removePieceModeleID(PieceModele $pieceModeleID): static
    {
        if ($this->pieceModeleID->removeElement($pieceModeleID)) {
            // set the owning side to null (unless already changed)
            if ($pieceModeleID->getPieceCaracteristique() === $this) {
                $pieceModeleID->setPieceCaracteristique(null);
            }
        }

        return $this;
    }

    public function getFaceCommune(): ?string
    {
        return $this->pieceFaceCommune;
    }

    public function setFaceCommune(string $pieceFaceCommune): static
    {
        $this->pieceFaceCommune = $pieceFaceCommune;

        return $this;
    }

    public function getMasse(): ?int
    {
        return $this->pieceMasse;
    }

    public function setMasse(int $pieceMasse): static
    {
        $this->pieceMasse = $pieceMasse;

        return $this;
    }

    public function getTaille(): ?int
    {
        return $this->pieceTaille;
    }

    public function setTaille(int $pieceTaille): static
    {
        $this->pieceTaille = $pieceTaille;

        return $this;
    }

    public function getMateriau(): ?string
    {
        return $this->pieceMateriau;
    }

    public function setMateriau(string $pieceMateriau): static
    {
        $this->pieceMateriau = $pieceMateriau;

        return $this;
    }
}
