<?php

namespace App\Entity;

use App\Repository\PieceTrancheRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: PieceTrancheRepository::class)]
class PieceTranche
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\OneToMany(targetEntity: PieceModele::class, mappedBy: 'pieceTranche')]
    private Collection $pieceModeleID;

    #[ORM\Column(length: 250)]
    private ?string $tranche = null;

    public function __construct()
    {
        $this->pieceModeleID = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    /**
     * @return Collection<int, PieceModele>
     */
    public function getPieceModeleID(): Collection
    {
        return $this->pieceModeleID;
    }

    public function addPieceModeleID(PieceModele $pieceModeleID): static
    {
        if (!$this->pieceModeleID->contains($pieceModeleID)) {
            $this->pieceModeleID->add($pieceModeleID);
            $pieceModeleID->setPieceTranche($this);
        }

        return $this;
    }

    public function removePieceModeleID(PieceModele $pieceModeleID): static
    {
        if ($this->pieceModeleID->removeElement($pieceModeleID)) {
            // set the owning side to null (unless already changed)
            if ($pieceModeleID->getPieceTranche() === $this) {
                $pieceModeleID->setPieceTranche(null);
            }
        }

        return $this;
    }

    public function getTranche(): ?string
    {
        return $this->tranche;
    }

    public function setTranche(string $tranche): static
    {
        $this->tranche = $tranche;

        return $this;
    }
}
